std::literals::chrono_literals::operator""ns(3)

NAME
std::literals::chrono_literals::operator""ns - std::literals::chrono_literals::operator""ns

Synopsis
   Defined in header <chrono>
   constexpr std::chrono::nanoseconds operator "" ns(unsigned long (1) (since C++14)
   long nsec);
   constexpr std::chrono::duration</*unspecified*/, (2) (since C++14)
   std::nano> operator "" ns(long double nsec);
   Forms a std::chrono::duration literal representing nanoseconds.
   1) integer literal, returns exactly std::chrono::nanoseconds(nsec)
   2) floating-point literal, returns a floating-point duration equivalent to
   std::chrono::nanoseconds

Parameters
   nsec - the number of nanoseconds

Return value
   The std::chrono::duration literal.

Possible implementation
   constexpr std::chrono::nanoseconds operator ""ns(unsigned long long ns)
   {
       return std::chrono::nanoseconds(ns);
   }
   constexpr std::chrono::duration<long double, std::nano> operator ""ns(long double ns)
   {
       return std::chrono::duration<long double, std::nano>(ns);
   }

Notes
   These operators are declared in the namespace std::literals::chrono_literals, where
   both literals and chrono_literals are inline namespaces. Access to these operators
   can be gained with using namespace std::literals, using namespace
   std::chrono_literals, and using namespace std::literals::chrono_literals.
   In addition, within the namespace std::chrono, the directive using namespace
   literals::chrono_literals; is provided by the standard library, so that if a
   programmer uses using namespace std::chrono; to gain access to the classes in the
   chrono library, the corresponding literal operators become visible as well.

Example

// Run this code
 #include <iostream>
 #include <chrono>
 int main()
 {
     using namespace std::chrono_literals;
     auto d1 = 250ns;
     std::chrono::nanoseconds d2 = 1us;
     std::cout << "250ns = " << d1.count() << " nanoseconds\n"
               << "1us = " << d2.count() << " nanoseconds\n";
 }

Output:
 250ns = 250 nanoseconds
 1us = 1000 nanoseconds

See also
   constructor constructs new duration
                 (public member function of std::chrono::duration<Rep,Period>)